/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/


#ifndef MINVAR
#define MINVAR   // if not defined, define and include rest of file.

#ifndef __cplusplus
#define __cplusplus
#endif

#include "PlotWindow.h"
#include "qdutil.h"
#include "qplug_if.h"
#include "Qdos.h"

//#define VERBOSE_MV   // uncomment for extra diagnostics


/* C++ prototypes */


void mvplot(QdRMatrixSeq_var vts_out, 
            QdRMatrix_var Eigenvalues, QdRMatrix_var Rmatx, int constrained);

QplugReturnStatus  MV_analyseB0(QdRMatrixSeq_var ts_out,
				QdRMatrixSeq_var ts_out2,
				QdRMatrix_var Eigenvalues,
				QdRMatrix_var Rmatx, 
				QdRMatrix_var Proj_matx,
				QdRMatrix_var Covar_matx,
				int constrained,int nestsize,
				const char *SC__ID, const int Qsel=0);



QplugReturnStatus   MV_plot_results(QdRMatrixSeq_var vts_out, 
                                    QdRMatrix_var Eigenvalues, 
				    QdRMatrix_var Rmatx,
			            int constrained);

extern "C" {


}  // end extern "C"
  
#endif    // end define MINVAR
