/* geopack.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#ifdef __cplusplus
extern "C" {
#endif

#include <stddef.h> 
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include "f2c.h"
/* Common Block Declarations */

union {
    struct {
	real st0, ct0, sl0, cl0, ctcl, stcl, ctsl, stsl, sfi, cfi, sps, cps, 
		shi, chi, hi, psi, xmut, a11, a21, a31, a12, a22, a32, a13, 
		a23, a33, ds3;
	integer k, iy;
	real cgst, sgst, ba[6];
    } _1;
    struct {
	real st0, ct0, sl0, cl0, ctcl, stcl, ctsl, stsl, ab[19];
	integer k, iy;
	real bb[8];
    } _2;
    struct {
	real a[27];
	integer kkkk[2];
	real cgst, sgst, b[6];
    } _3;
    struct {
	real a[8], sfi, cfi, b[7], ab[10];
	integer k, iy;
	real ba[8];
    } _4;
    struct {
	real a[12], shi, chi, ab[13];
	integer k, iy;
	real ba[8];
    } _5;
    struct {
	real a[10], sps, cps, b[15];
	integer k, iy;
	real ab[8];
    } _6;
    struct {
	real aa[17], a11, a21, a31, a12, a22, a32, a13, a23, a33, d__;
	integer k, iy;
	real b[8];
    } _7;
    struct {
	real a[15], psi, aa[10], ds3;
	integer k, iy;
	real bb[8];
    } _8;
    struct {
	real a[26], ds3;
	integer k, iy;
	real b[8];
    } _9;
    struct {
	real aa[26], dd;
	integer k1, k2;
	real bb[8];
    } _10;
} geopack_;

#define geopack_1 (geopack_._1)
#define geopack_2 (geopack_._2)
#define geopack_3 (geopack_._3)
#define geopack_4 (geopack_._4)
#define geopack_5 (geopack_._5)
#define geopack_6 (geopack_._6)
#define geopack_7 (geopack_._7)
#define geopack_8 (geopack_._8)
#define geopack_9 (geopack_._9)
#define geopack_10 (geopack_._10)

/* Table of constant values */

static integer c__1 = 1;
static doublereal c_b37 = 360.;
static integer c__0 = 0;
static integer c__25 = 25;
static integer c_n1 = -1;
static real c_b78 = (float).01;

/* ============================================================================ */
/* ============================================================================ */
/* ============================================================================ */

/* ########################################################################## */
/* #                                                                        # */
/* #                              GEOPACK                                   # */
/* #                     (MAIN SET OF FORTRAN CODES)                        # */
/* #                                                                        # */
/* ########################################################################## */


/*    This collection of subroutines is a result of several upgrades of the original */
/*      package by N. A. Tsyganenko. This release is dated by January 5, 2001. */

/*    Please see the additional file geopack.txt for descriptions of the individual */
/*    subroutines. */

/*    The following changes were made to the previous release of April 16, 1996: */

/*       (1) The latest set of IGRF expansion coefficients for the epoch 2000.0 */
/*    was added, so that the updated version of the main field model accepts */
/*    dates through 2005. */

/*       (2) All explicit type statements as well as IMPLICIT NONE were taken */
/*    out from all subroutines, for the sake of brevity. */
/*       (3) To avoid potential run-time errors on some types of FORTRAN compilers, */
/*    the SAVE statements were added in the subroutines IGRF, DIP, RECALC, GEOMAG. */

/*       (4) In the tracing subroutine TRACE, more harmonic terms were allowed */
/*    to be included in the main field expansion (IGRF) for maintaining a higher */
/*    accuracy. */

/*       (5) An update and some correction/editing of the documentation file */
/*    GEOPACK.TXT was made. */


/* ---------------------------------------------------------------------------------- */

/* Subroutine */ int igrf_(integer *iy, integer *nm, real *r__, real *t, real 
	*f, real *br, real *bt, real *bf)
{
    /* Initialized data */

    static real g65[66] = { (float)0.,(float)-30334.,(float)-2119.,(float)
	    -1662.,(float)2997.,(float)1594.,(float)1297.,(float)-2038.,(
	    float)1292.,(float)856.,(float)957.,(float)804.,(float)479.,(
	    float)-390.,(float)252.,(float)-219.,(float)358.,(float)254.,(
	    float)-31.,(float)-157.,(float)-62.,(float)45.,(float)61.,(float)
	    8.,(float)-228.,(float)4.,(float)1.,(float)-111.,(float)75.,(
	    float)-57.,(float)4.,(float)13.,(float)-26.,(float)-6.,(float)13.,
	    (float)1.,(float)13.,(float)5.,(float)-4.,(float)-14.,(float)0.,(
	    float)8.,(float)-1.,(float)11.,(float)4.,(float)8.,(float)10.,(
	    float)2.,(float)-13.,(float)10.,(float)-1.,(float)-1.,(float)5.,(
	    float)1.,(float)-2.,(float)-2.,(float)-3.,(float)2.,(float)-5.,(
	    float)-2.,(float)4.,(float)4.,(float)0.,(float)2.,(float)2.,(
	    float)0. };
    static real h65[66] = { (float)0.,(float)0.,(float)5776.,(float)0.,(float)
	    -2016.,(float)114.,(float)0.,(float)-404.,(float)240.,(float)
	    -165.,(float)0.,(float)148.,(float)-269.,(float)13.,(float)-269.,(
	    float)0.,(float)19.,(float)128.,(float)-126.,(float)-97.,(float)
	    81.,(float)0.,(float)-11.,(float)100.,(float)68.,(float)-32.,(
	    float)-8.,(float)-7.,(float)0.,(float)-61.,(float)-27.,(float)-2.,
	    (float)6.,(float)26.,(float)-23.,(float)-12.,(float)0.,(float)7.,(
	    float)-12.,(float)9.,(float)-16.,(float)4.,(float)24.,(float)-3.,(
	    float)-17.,(float)0.,(float)-22.,(float)15.,(float)7.,(float)-4.,(
	    float)-5.,(float)10.,(float)10.,(float)-4.,(float)1.,(float)0.,(
	    float)2.,(float)1.,(float)2.,(float)6.,(float)-4.,(float)0.,(
	    float)-2.,(float)3.,(float)0.,(float)-6. };
    static real g70[66] = { (float)0.,(float)-30220.,(float)-2068.,(float)
	    -1781.,(float)3e3,(float)1611.,(float)1287.,(float)-2091.,(float)
	    1278.,(float)838.,(float)952.,(float)800.,(float)461.,(float)
	    -395.,(float)234.,(float)-216.,(float)359.,(float)262.,(float)
	    -42.,(float)-160.,(float)-56.,(float)43.,(float)64.,(float)15.,(
	    float)-212.,(float)2.,(float)3.,(float)-112.,(float)72.,(float)
	    -57.,(float)1.,(float)14.,(float)-22.,(float)-2.,(float)13.,(
	    float)-2.,(float)14.,(float)6.,(float)-2.,(float)-13.,(float)-3.,(
	    float)5.,(float)0.,(float)11.,(float)3.,(float)8.,(float)10.,(
	    float)2.,(float)-12.,(float)10.,(float)-1.,(float)0.,(float)3.,(
	    float)1.,(float)-1.,(float)-3.,(float)-3.,(float)2.,(float)-5.,(
	    float)-1.,(float)6.,(float)4.,(float)1.,(float)0.,(float)3.,(
	    float)-1. };
    static real h70[66] = { (float)0.,(float)0.,(float)5737.,(float)0.,(float)
	    -2047.,(float)25.,(float)0.,(float)-366.,(float)251.,(float)-196.,
	    (float)0.,(float)167.,(float)-266.,(float)26.,(float)-279.,(float)
	    0.,(float)26.,(float)139.,(float)-139.,(float)-91.,(float)83.,(
	    float)0.,(float)-12.,(float)100.,(float)72.,(float)-37.,(float)
	    -6.,(float)1.,(float)0.,(float)-70.,(float)-27.,(float)-4.,(float)
	    8.,(float)23.,(float)-23.,(float)-11.,(float)0.,(float)7.,(float)
	    -15.,(float)6.,(float)-17.,(float)6.,(float)21.,(float)-6.,(float)
	    -16.,(float)0.,(float)-21.,(float)16.,(float)6.,(float)-4.,(float)
	    -5.,(float)10.,(float)11.,(float)-2.,(float)1.,(float)0.,(float)
	    1.,(float)1.,(float)3.,(float)4.,(float)-4.,(float)0.,(float)-1.,(
	    float)3.,(float)1.,(float)-4. };
    static real g75[66] = { (float)0.,(float)-30100.,(float)-2013.,(float)
	    -1902.,(float)3010.,(float)1632.,(float)1276.,(float)-2144.,(
	    float)1260.,(float)830.,(float)946.,(float)791.,(float)438.,(
	    float)-405.,(float)216.,(float)-218.,(float)356.,(float)264.,(
	    float)-59.,(float)-159.,(float)-49.,(float)45.,(float)66.,(float)
	    28.,(float)-198.,(float)1.,(float)6.,(float)-111.,(float)71.,(
	    float)-56.,(float)1.,(float)16.,(float)-14.,(float)0.,(float)12.,(
	    float)-5.,(float)14.,(float)6.,(float)-1.,(float)-12.,(float)-8.,(
	    float)4.,(float)0.,(float)10.,(float)1.,(float)7.,(float)10.,(
	    float)2.,(float)-12.,(float)10.,(float)-1.,(float)-1.,(float)4.,(
	    float)1.,(float)-2.,(float)-3.,(float)-3.,(float)2.,(float)-5.,(
	    float)-2.,(float)5.,(float)4.,(float)1.,(float)0.,(float)3.,(
	    float)-1. };
    static real h75[66] = { (float)0.,(float)0.,(float)5675.,(float)0.,(float)
	    -2067.,(float)-68.,(float)0.,(float)-333.,(float)262.,(float)
	    -223.,(float)0.,(float)191.,(float)-265.,(float)39.,(float)-288.,(
	    float)0.,(float)31.,(float)148.,(float)-152.,(float)-83.,(float)
	    88.,(float)0.,(float)-13.,(float)99.,(float)75.,(float)-41.,(
	    float)-4.,(float)11.,(float)0.,(float)-77.,(float)-26.,(float)-5.,
	    (float)10.,(float)22.,(float)-23.,(float)-12.,(float)0.,(float)6.,
	    (float)-16.,(float)4.,(float)-19.,(float)6.,(float)18.,(float)
	    -10.,(float)-17.,(float)0.,(float)-21.,(float)16.,(float)7.,(
	    float)-4.,(float)-5.,(float)10.,(float)11.,(float)-3.,(float)1.,(
	    float)0.,(float)1.,(float)1.,(float)3.,(float)4.,(float)-4.,(
	    float)-1.,(float)-1.,(float)3.,(float)1.,(float)-5. };
    static real g80[66] = { (float)0.,(float)-29992.,(float)-1956.,(float)
	    -1997.,(float)3027.,(float)1663.,(float)1281.,(float)-2180.,(
	    float)1251.,(float)833.,(float)938.,(float)782.,(float)398.,(
	    float)-419.,(float)199.,(float)-218.,(float)357.,(float)261.,(
	    float)-74.,(float)-162.,(float)-48.,(float)48.,(float)66.,(float)
	    42.,(float)-192.,(float)4.,(float)14.,(float)-108.,(float)72.,(
	    float)-59.,(float)2.,(float)21.,(float)-12.,(float)1.,(float)11.,(
	    float)-2.,(float)18.,(float)6.,(float)0.,(float)-11.,(float)-7.,(
	    float)4.,(float)3.,(float)6.,(float)-1.,(float)5.,(float)10.,(
	    float)1.,(float)-12.,(float)9.,(float)-3.,(float)-1.,(float)7.,(
	    float)2.,(float)-5.,(float)-4.,(float)-4.,(float)2.,(float)-5.,(
	    float)-2.,(float)5.,(float)3.,(float)1.,(float)2.,(float)3.,(
	    float)0. };
    static real h80[66] = { (float)0.,(float)0.,(float)5604.,(float)0.,(float)
	    -2129.,(float)-200.,(float)0.,(float)-336.,(float)271.,(float)
	    -252.,(float)0.,(float)212.,(float)-257.,(float)53.,(float)-297.,(
	    float)0.,(float)46.,(float)150.,(float)-151.,(float)-78.,(float)
	    92.,(float)0.,(float)-15.,(float)93.,(float)71.,(float)-43.,(
	    float)-2.,(float)17.,(float)0.,(float)-82.,(float)-27.,(float)-5.,
	    (float)16.,(float)18.,(float)-23.,(float)-10.,(float)0.,(float)7.,
	    (float)-18.,(float)4.,(float)-22.,(float)9.,(float)16.,(float)
	    -13.,(float)-15.,(float)0.,(float)-21.,(float)16.,(float)9.,(
	    float)-5.,(float)-6.,(float)9.,(float)10.,(float)-6.,(float)2.,(
	    float)0.,(float)1.,(float)0.,(float)3.,(float)6.,(float)-4.,(
	    float)0.,(float)-1.,(float)4.,(float)0.,(float)-6. };
    static real g85[66] = { (float)0.,(float)-29873.,(float)-1905.,(float)
	    -2072.,(float)3044.,(float)1687.,(float)1296.,(float)-2208.,(
	    float)1247.,(float)829.,(float)936.,(float)780.,(float)361.,(
	    float)-424.,(float)170.,(float)-214.,(float)355.,(float)253.,(
	    float)-93.,(float)-164.,(float)-46.,(float)53.,(float)65.,(float)
	    51.,(float)-185.,(float)4.,(float)16.,(float)-102.,(float)74.,(
	    float)-62.,(float)3.,(float)24.,(float)-6.,(float)4.,(float)10.,(
	    float)0.,(float)21.,(float)6.,(float)0.,(float)-11.,(float)-9.,(
	    float)4.,(float)4.,(float)4.,(float)-4.,(float)5.,(float)10.,(
	    float)1.,(float)-12.,(float)9.,(float)-3.,(float)-1.,(float)7.,(
	    float)1.,(float)-5.,(float)-4.,(float)-4.,(float)3.,(float)-5.,(
	    float)-2.,(float)5.,(float)3.,(float)1.,(float)2.,(float)3.,(
	    float)0. };
    static real h85[66] = { (float)0.,(float)0.,(float)5500.,(float)0.,(float)
	    -2197.,(float)-306.,(float)0.,(float)-310.,(float)284.,(float)
	    -297.,(float)0.,(float)232.,(float)-249.,(float)69.,(float)-297.,(
	    float)0.,(float)47.,(float)150.,(float)-154.,(float)-75.,(float)
	    95.,(float)0.,(float)-16.,(float)88.,(float)69.,(float)-48.,(
	    float)-1.,(float)21.,(float)0.,(float)-83.,(float)-27.,(float)-2.,
	    (float)20.,(float)17.,(float)-23.,(float)-7.,(float)0.,(float)8.,(
	    float)-19.,(float)5.,(float)-23.,(float)11.,(float)14.,(float)
	    -15.,(float)-11.,(float)0.,(float)-21.,(float)15.,(float)9.,(
	    float)-6.,(float)-6.,(float)9.,(float)9.,(float)-7.,(float)2.,(
	    float)0.,(float)1.,(float)0.,(float)3.,(float)6.,(float)-4.,(
	    float)0.,(float)-1.,(float)4.,(float)0.,(float)-6. };
    static real g90[66] = { (float)0.,(float)-29775.,(float)-1848.,(float)
	    -2131.,(float)3059.,(float)1686.,(float)1314.,(float)-2239.,(
	    float)1248.,(float)802.,(float)939.,(float)780.,(float)325.,(
	    float)-423.,(float)141.,(float)-214.,(float)353.,(float)245.,(
	    float)-109.,(float)-165.,(float)-36.,(float)61.,(float)65.,(float)
	    59.,(float)-178.,(float)3.,(float)18.,(float)-96.,(float)77.,(
	    float)-64.,(float)2.,(float)26.,(float)-1.,(float)5.,(float)9.,(
	    float)0.,(float)23.,(float)5.,(float)-1.,(float)-10.,(float)-12.,(
	    float)3.,(float)4.,(float)2.,(float)-6.,(float)4.,(float)9.,(
	    float)1.,(float)-12.,(float)9.,(float)-4.,(float)-2.,(float)7.,(
	    float)1.,(float)-6.,(float)-3.,(float)-4.,(float)2.,(float)-5.,(
	    float)-2.,(float)4.,(float)3.,(float)1.,(float)3.,(float)3.,(
	    float)0. };
    static real h90[66] = { (float)0.,(float)0.,(float)5406.,(float)0.,(float)
	    -2279.,(float)-373.,(float)0.,(float)-284.,(float)293.,(float)
	    -352.,(float)0.,(float)247.,(float)-240.,(float)84.,(float)-299.,(
	    float)0.,(float)46.,(float)154.,(float)-153.,(float)-69.,(float)
	    97.,(float)0.,(float)-16.,(float)82.,(float)69.,(float)-52.,(
	    float)1.,(float)24.,(float)0.,(float)-80.,(float)-26.,(float)0.,(
	    float)21.,(float)17.,(float)-23.,(float)-4.,(float)0.,(float)10.,(
	    float)-19.,(float)6.,(float)-22.,(float)12.,(float)12.,(float)
	    -16.,(float)-10.,(float)0.,(float)-20.,(float)15.,(float)11.,(
	    float)-7.,(float)-7.,(float)9.,(float)8.,(float)-7.,(float)2.,(
	    float)0.,(float)2.,(float)1.,(float)3.,(float)6.,(float)-4.,(
	    float)0.,(float)-2.,(float)3.,(float)-1.,(float)-6. };
    static real g95[66] = { (float)0.,(float)-29692.,(float)-1784.,(float)
	    -2200.,(float)3070.,(float)1681.,(float)1335.,(float)-2267.,(
	    float)1249.,(float)759.,(float)940.,(float)780.,(float)290.,(
	    float)-418.,(float)122.,(float)-214.,(float)352.,(float)235.,(
	    float)-118.,(float)-166.,(float)-17.,(float)68.,(float)67.,(float)
	    68.,(float)-170.,(float)-1,(float)19.,(float)-93.,(float)77.,(
	    float)-72.,(float)1.,(float)28.,(float)5.,(float)4.,(float)8.,(
	    float)-2.,(float)25.,(float)6.,(float)-6.,(float)-9.,(float)-14.,(
	    float)9.,(float)6.,(float)-5.,(float)-7.,(float)4.,(float)9.,(
	    float)3.,(float)-10.,(float)8.,(float)-8.,(float)-1.,(float)10.,(
	    float)-2.,(float)-8.,(float)-3.,(float)-6.,(float)2.,(float)-4.,(
	    float)-1.,(float)4.,(float)2.,(float)2.,(float)5.,(float)1.,(
	    float)0. };
    static real h95[66] = { (float)0.,(float)0.,(float)5306.,(float)0.,(float)
	    -2366.,(float)-413.,(float)0.,(float)-262.,(float)302.,(float)
	    -427.,(float)0.,(float)262.,(float)-236.,(float)97.,(float)-306.,(
	    float)0.,(float)46.,(float)165.,(float)-143.,(float)-55.,(float)
	    107.,(float)0.,(float)-17.,(float)72.,(float)67.,(float)-58.,(
	    float)1.,(float)36.,(float)0.,(float)-69.,(float)-25.,(float)4.,(
	    float)24.,(float)17.,(float)-24.,(float)-6.,(float)0.,(float)11.,(
	    float)-21.,(float)8.,(float)-23.,(float)15.,(float)11.,(float)
	    -16.,(float)-4.,(float)0.,(float)-20.,(float)15.,(float)12.,(
	    float)-6.,(float)-8.,(float)8.,(float)5.,(float)-8.,(float)3.,(
	    float)0.,(float)1.,(float)0.,(float)4.,(float)5.,(float)-5.,(
	    float)-1.,(float)-2.,(float)1.,(float)-2.,(float)-7. };
    static real g00[66] = { (float)0.,(float)-29619.4,(float)-1728.2,(float)
	    -2267.7,(float)3068.4,(float)1670.9,(float)1339.6,(float)-2280.,(
	    float)1252.1,(float)714.5,(float)932.3,(float)786.8,(float)250.,(
	    float)-403.,(float)111.3,(float)-218.8,(float)351.4,(float)222.3,(
	    float)-130.4,(float)-168.6,(float)-12.9,(float)72.3,(float)68.2,(float)
	    74.2,(float)-160.9,(float)-5.9,(float)16.9,(float)-90.4,(float)79.,(
	    float)-74.,(float)0.,(float)33.3,(float)9.1,(float)6.9,(float)7.3,(
	    float)-1.2,(float)24.4,(float)6.6,(float)-9.2,(float)-7.9,(float)-16.6,(
	    float)9.1,(float)7.,(float)-7.9,(float)-7.,(float)5.,(float)9.4,(
	    float)3.,(float)-8.4,(float)6.3,(float)-8.9,(float)-1.5,(float)9.3,(
	    float)-4.3,(float)-8.2,(float)-2.6,(float)-6.,(float)1.7,(float)-3.1,(
	    float)-0.5,(float)3.7,(float)1.,(float)2.,(float)4.2,(float)0.3,(float)
	    -1.1 };
    static real h00[66] = { (float)0.,(float)0.,(float)5186.1,(float)0.,(float)
	    -2481.6,(float)-458.,(float)0.,(float)-227.6,(float)293.4,(float)
	    -491.1,(float)0.,(float)272.6,(float)-231.9,(float)119.8,(float)-303.8,
	    (float)0.,(float)43.8,(float)171.9,(float)-133.1,(float)-39.3,(float)
	    106.3,(float)0.,(float)-17.4,(float)63.7,(float)65.1,(float)-61.2,(
	    float)0.7,(float)43.8,(float)0.,(float)-64.6,(float)-24.2,(float)6.2,(
	    float)24.,(float)14.8,(float)-25.4,(float)-5.8,(float)0.,(float)11.9,(
	    float)-21.5,(float)8.5,(float)-21.5,(float)15.5,(float)8.9,(float)-14.9,
	    (float)-2.1,(float)0.,(float)-19.7,(float)13.4,(float)12.5,(float)-6.2,
	    (float)-8.4,(float)8.4,(float)3.8,(float)-8.2,(float)4.8,(float)0.,(
	    float)1.7,(float)0.,(float)4.,(float)4.9,(float)-55.9,(float)-1.2,(
	    float)-2.9,(float)0.2,(float)-2.2,(float)-7.4 };
    static real g05[66] = { (float)0.,(float)-29554.63,(float)-1669.05,(float)
	    -2337.24,(float)3047.69,(float)1657.76,(float)1336.30,(float)-2305.83,(
	    float)1246.39,(float)672.51,(float)920.55,(float)797.96,(float)210.65,(
	    float)-379.86,(float)100.,(float)-227.,(float)354.41,(float)208.95,(
	    float)-136.54,(float)-168.05,(float)-13.55,(float)73.60,(float)69.65,(float)
	    76.74,(float)-151.34,(float)-14.58,(float)14.58,(float)-86.36,(float)79.88,(
	    float)-74.46,(float)-1.65,(float)38.73,(float)12.30,(float)9.37,(float)5.42,(
	    float)1.94,(float)24.80,(float)7.62,(float)-11.73,(float)-6.88,(float)-18.11,(
	    float)10.17,(float)9.36,(float)-11.25,(float)-4.87,(float)5.58,(float)9.76,(
	    float)3.58,(float)-6.94,(float)5.01,(float)-10.76,(float)-1.25,(float)8.76,(
	    float)-6.66,(float)-9.22,(float)-2.17,(float)-6.12,(float)1.42,(float)-2.35,(
	    float)-0.15,(float)3.06,(float)0.29,(float)2.06,(float)3.77,(float)-0.21,(float)
	    -2.09 };
    static real h05[66] = { (float)0.,(float)0.,(float)5077.99,(float)0.,(float)
	    -2594.5,(float)-515.43,(float)0.,(float)-198.86,(float)269.72,(float)
	    -524.72,(float)0.,(float)282.07,(float)-225.23,(float)154.15,(float)-305.36,
	    (float)0.,(float)42.72,(float)180.25,(float)-123.45,(float)-19.57,(float)
	    103.85,(float)0.,(float)-20.33,(float)54.75,(float)63.63,(float)-63.53,(
	    float)0.24,(float)50.94,(float)0.,(float)-61.14,(float)-22.57,(float)6.82,(
	    float)25.35,(float)10.93,(float)-26.32,(float)-4.64,(float)0.,(float)11.2,(
	    float)-20.88,(float)9.83,(float)-19.71,(float)16.22,(float)7.61,(float)-12.76,
	    (float)-0.06,(float)0.,(float)-20.11,(float)12.69,(float)12.67,(float)-6.72,
	    (float)-8.16,(float)8.10,(float)2.92,(float)-7.73,(float)6.01,(float)0.,(
	    float)2.19,(float)0.10,(float)4.46,(float)4.76,(float)-6.58,(float)-1.01,(
	    float)-3.47,(float)-0.86,(float)-2.31,(float)-7.93 };
    static real g10[66] = { (float)0.,(float)-29496.5,(float)-1585.9,(float)
	    -2396.6,(float)3026.,(float)1668.6,(float)1339.7,(float)-2326.3,(
	    float)1231.7,(float)634.2,(float)912.6,(float)809.,(float)166.6,(
	    float)-357.1,(float)89.7,(float)-231.1,(float)357.2,(float)200.3,(
	    float)-141.2,(float)-163.1,(float)-7.7,(float)72.8,(float)68.6,(float)
	    76.0,(float)-141.4,(float)-22.9,(float)13.1,(float)-77.9,(float)80.4,(
	    float)-75.,(float)-4.7,(float)45.3,(float)14.0,(float)10.4,(float)1.6,(
	    float)4.9,(float)24.3,(float)8.2,(float)-14.5,(float)-5.7,(float)-19.3,(
	    float)11.6,(float)10.9,(float)-14.1,(float)-3.7,(float)5.4,(float)9.4,(
	    float)3.4,(float)-5.3,(float)3.1,(float)-12.4,(float)-0.8,(float)8.4,(
	    float)-8.4,(float)-10.1,(float)-2.,(float)-6.3,(float)0.9,(float)-1.1,(
	    float)-0.2,(float)2.5,(float)-0.3,(float)2.2,(float)3.1,(float)-1.0,(float)-2.8 };
    static real h10[66] = { (float)0.,(float)0.,(float)4945.1,(float)0.,(float)
	    -2707.7,(float)-575.4,(float)0.,(float)-160.5,(float)251.7,(float)
	    -536.8,(float)0.,(float)286.4,(float)-211.2,(float)164.4,(float)-309.2,
	    (float)0.,(float)44.7,(float)188.9,(float)-118.1,(float)0.1,(float)
	    100.9,(float)0.,(float)-20.8,(float)44.2,(float)61.5,(float)-66.3,(
	    float)3.1,(float)54.9,(float)0.,(float)-57.8,(float)-21.2,(float)6.6,(
	    float)24.9,(float)7.,(float)-27.7,(float)-3.4,(float)0.,(float)10.9,(
	    float)-20.,(float)11.9,(float)-17.4,(float)16.7,(float)7.1,(float)-10.8,
	    (float)1.7,(float)0.,(float)-20.5,(float)11.6,(float)12.8,(float)-7.2,
	    (float)-7.4,(float)8.,(float)2.2,(float)-6.1,(float)7.,(float)0.,(
	    float)2.8,(float)-0.1,(float)4.7,(float)4.4,(float)-7.2,(float)-1.,(
	    float)-4.,(float)-2.0,(float)-2.,(float)-8.3 };
    static real dg10[45] = { (float)0.,(float)11.4,(float)16.7,(float)-11.3,(
	    float)-3.9,(float)2.7,(float)1.3,(float)-3.9,(float)-2.9,(float)-8.1,
	    (float)-1.4,(float)2.0,(float)-8.9,(float)4.4,(float)-2.3,(float)
	    -0.5,(float)0.5,(float)-1.5,(float)-0.7,(float)1.3,(float)1.4,(
	    float)-0.3,(float)-0.3,(float)-0.3,(float)1.9,(float)-1.6,(float)-0.2,(
	    float)1.8,(float)0.2,(float)-0.1,(float)-0.6,(float)1.4,(float)0.3,(
	    float)0.1,(float)-0.8,(float)0.4,(float)-0.1,(float)0.1,(float)-.5,(
	    float)0.3,(float)-0.3,(float)0.3,(float)0.2,(float)-0.5,(float)0.2 };
    static real dh10[45] = { (float)0.,(float)0.,(float)-28.8,(float)0.,(
	    float)-23.0,(float)-12.9,(float)0.,(float)8.6,(float)-2.9,(float)
	    -2.1,(float)0.,(float)0.4,(float)3.2,(float)3.6,(float)-0.8,(float)
	    0.,(float)0.5,(float)1.5,(float)0.9,(float)3.7,(float)-0.6,(float)0.,
	    (float)-0.1,(float)-2.1,(float)-0.4,(float)-0.5,(float)0.8,(float)0.5,(
	    float)0.,(float)0.6,(float)0.3,(float)-0.2,(float)-0.1,(float)-0.8,(
	    float)-0.3,(float)0.2,(float)0.,(float)0.,(float)0.2,(float)0.5,(
	    float)0.4,(float)0.1,(float)-0.1,(float)0.4,(float)0.4 };
    static integer ma = 0;
    static integer iyr = 0;
    static integer ipr = 0;


    /* System generated locals */
    integer i__1, i__2;

    /* Local variables */
    static real a[11], b[11], c__, d__, e, g[66], h__[66];
    static integer k, m, n;
    static real p, q, s, u, w, x, y, z__, d2, f1, f2;
    static integer n2;
    static real p2, aa, cf, bi;
    static integer mn;
    static real dt, pp, sf;
    static integer mm;
    static real an, hh, qq, xk, dp, pm, bbf, bbr, bbt, rec[66];
    static integer mnn;



/*     CALCULATES COMPONENTS OF THE MAIN (INTERNAL) GEOMAGNETIC FIELD IN SPHERICAL */
/*     GEOGRAPHICAL COORDINATE SYSTEM, USING IAGA INTERNATIONAL GEOMAGNETIC REFERENCE */
/*     MODEL COEFFICIENTS (e.g., http://www.ngdc.noaa.gov/IAGA/wg8/igrf2000.html) Updated Feb 2011 (11th Generation IGRF)*/

/*     UPDATING THE COEFFICIENTS TO A GIVEN EPOCH IS MADE AUTOMATICALLY UPON THE FIRST */
/*     CALL AND AFTER EVERY CHANGE OF THE PARAMETER IY. */

/* -----INPUT PARAMETERS: */

/*     IY  -  YEAR NUMBER (FOUR-DIGIT; 1965 &LE IY &LE 2005) */
/*     NM  -  HIGHEST ORDER OF SPHERICAL HARMONICS IN THE SCALAR POTENTIAL (NM &LE 10) */
/*     R,T,F -  SPHERICAL COORDINATES (RADIUS R IN UNITS RE=6371.2 KM, GEOGRAPHIC */
/*                COLATITUDE  T  AND LONGITUDE  F  IN RADIANS) */

/* -----OUTPUT PARAMETERS: */

/*     BR,BT,BF - SPHERICAL COMPONENTS OF THE MAIN GEOMAGNETIC FIELD IN NANOTESLA */

/*     LAST MODIFICATION:  JANUARY 5, 2001. */
/*     THE CODE WAS MODIFIED TO ACCEPT DATES THROUGH 2005. */
/*     IT HAS ALSO BEEN SLIGHTLY SIMPLIFIED BY TAKING OUT SOME REDUNDANT STATEMENTS, */
/*     AND A "SAVE" STATEMENT WAS ADDED, TO AVOID POTENTIAL PROBLEMS WITH SOME */
/*     FORTRAN COMPILERS. */

/*     WRITTEN BY: N. A. TSYGANENKO */

// Modified for later IGRF model A.J.Allen 2011


    if (ma != 1) {
	goto L10;
    }
    if (*iy != iyr) {
	goto L30;
    }
    goto L150;
L10:
    ma = 1;

    for (n = 1; n <= 11; ++n) {
	n2 = (n << 1) - 1;
	n2 *= n2 - 2;
	i__1 = n;
	for (m = 1; m <= i__1; ++m) {
	    mn = n * (n - 1) / 2 + m;
	    rec[mn - 1] = (real) ((n - m) * (n + m - 2)) / (real) n2;
	}
    }

L30:
    iyr = *iy;
    if (iyr < 1965) {
	iyr = 1965;
    }
    if (iyr > 2015) {
	iyr = 2015;
    }
    if (*iy != iyr && ipr == 0) {
    printf("(\nIGRF WARNS:**** YEAR IS OUT OF INTERVAL 1965-2015: IY =%d\n, CALCULATIONS WILL BE DONE FOR IYR=%d)", (int)*iy, (int)iyr);
    }
    if (iyr != *iy) {
	ipr = 1;
    }
/* INTERPOLATE BETWEEN 1965 - 1970 */
    if (iyr < 1970) {
		goto L50;
    }
/* INTERPOLATE BETWEEN 1970 - 1975 */
    if (iyr < 1975) {
	goto L60;
    }
/* INTERPOLATE BETWEEN 1975 - 1980 */
    if (iyr < 1980) {
	goto L70;
    }
/* INTERPOLATE BETWEEN 1980 - 1985 */
    if (iyr < 1985) {
	goto L80;
    }
/* INTERPOLATE BETWEEN 1985 - 1990 */
    if (iyr < 1990) {
	goto L90;
    }
/* INTERPOLATE BETWEEN 1990 - 1995 */
    if (iyr < 1995) {
	goto L100;
    }
/* INTERPOLATE BETWEEN 1995 - 2000 */
    if (iyr < 2000) {
	goto L110;
    }
/* INTERPOLATE BETWEEN 2000 - 2005 */
    if (iyr < 2005) {
	goto L120;
    }
/* INTERPOLATE BETWEEN 2005 - 2010 */
    if (iyr < 2010) {
	goto L130;
    }

/*       EXTRAPOLATE BEYOND 2010: */

    dt = (real) iyr - (float)2010;
    for (n = 1; n <= 66; ++n) {
		g[n - 1] = g10[n - 1];
		h__[n - 1] = h10[n - 1];
		if (n <= 45) {
			g[n - 1] += dg10[n - 1] * dt;
			h__[n - 1] += dh10[n - 1] * dt;
		}
    }
    goto L300;

/*       INTERPOLATE BETWEEEN 1965 - 1970: */

L50:
    f2 = (iyr - 1965) / (float)5.;
    f1 = (float)1. - f2;
    for (n = 1; n <= 66; ++n) {
	g[n - 1] = g65[n - 1] * f1 + g70[n - 1] * f2;
	h__[n - 1] = h65[n - 1] * f1 + h70[n - 1] * f2;
    }
    goto L300;

/*       INTERPOLATE BETWEEN 1970 - 1975: */

L60:
    f2 = (iyr - 1970) / (float)5.;
    f1 = (float)1. - f2;
    for (n = 1; n <= 66; ++n) {
	g[n - 1] = g70[n - 1] * f1 + g75[n - 1] * f2;
	h__[n - 1] = h70[n - 1] * f1 + h75[n - 1] * f2;
    }
    goto L300;

/*       INTERPOLATE BETWEEN 1975 - 1980: */

L70:
    f2 = (iyr - 1975) / (float)5.;
    f1 = (float)1. - f2;
    for (n = 1; n <= 66; ++n) {
	g[n - 1] = g75[n - 1] * f1 + g80[n - 1] * f2;
	h__[n - 1] = h75[n - 1] * f1 + h80[n - 1] * f2;
    }
    goto L300;

/*       INTERPOLATE BETWEEN 1980 - 1985: */

L80:
    f2 = (iyr - 1980) / (float)5.;
    f1 = (float)1. - f2;
    for (n = 1; n <= 66; ++n) {
	g[n - 1] = g80[n - 1] * f1 + g85[n - 1] * f2;
	h__[n - 1] = h80[n - 1] * f1 + h85[n - 1] * f2;
    }
    goto L300;

/*       INTERPOLATE BETWEEN 1985 - 1990: */

L90:
    f2 = (iyr - 1985) / (float)5.;
    f1 = (float)1. - f2;
    for (n = 1; n <= 66; ++n) {
	g[n - 1] = g85[n - 1] * f1 + g90[n - 1] * f2;
	h__[n - 1] = h85[n - 1] * f1 + h90[n - 1] * f2;
    }
    goto L300;

/*       INTERPOLATE BETWEEN 1990 - 1995: */

L100:
    f2 = (iyr - 1990) / (float)5.;
    f1 = (float)1. - f2;
    for (n = 1; n <= 66; ++n) {
	g[n - 1] = g90[n - 1] * f1 + g95[n - 1] * f2;
	h__[n - 1] = h90[n - 1] * f1 + h95[n - 1] * f2;
    }
    goto L300;

/*       INTERPOLATE BETWEEN 1995 - 2000: */

L110:
    f2 = (iyr - 1995) / (float)5.;
    f1 = (float)1. - f2;
    for (n = 1; n <= 66; ++n) {
	g[n - 1] = g95[n - 1] * f1 + g00[n - 1] * f2;
	h__[n - 1] = h95[n - 1] * f1 + h00[n - 1] * f2;
    }
    goto L300;

L120:
    f2 = (iyr - 2000) / (float)5.;
    f1 = (float)1. - f2;
    for (n = 1; n <= 66; ++n) {
	g[n - 1] = g00[n - 1] * f1 + g05[n - 1] * f2;
	h__[n - 1] = h00[n - 1] * f1 + h05[n - 1] * f2;
    }
    goto L300;

L130:
    f2 = (iyr - 2005) / (float)5.;
    f1 = (float)1. - f2;
    for (n = 1; n <= 66; ++n) {
	g[n - 1] = g05[n - 1] * f1 + g10[n - 1] * f2;
	h__[n - 1] = h05[n - 1] * f1 + h10[n - 1] * f2;
    }
    goto L300;

/*   COEFFICIENTS FOR A GIVEN YEAR HAVE BEEN CALCULATED; NOW MULTIPLY */
/*   THEM BY SCHMIDT NORMALIZATION FACTORS: */

L300:
    s = (float)1.;
    for (n = 2; n <= 11; ++n) {
	mn = n * (n - 1) / 2 + 1;
	s = s * (real) ((n << 1) - 3) / (real) (n - 1);
	g[mn - 1] *= s;
	h__[mn - 1] *= s;
	p = s;
	i__1 = n;
	for (m = 2; m <= i__1; ++m) {
	    aa = (float)1.;
	    if (m == 2) {
		aa = (float)2.;
	    }
	    p *= sqrt(aa * (real) (n - m + 1) / (real) (n + m - 2));
	    mnn = mn + m - 1;
	    g[mnn - 1] *= p;
	    h__[mnn - 1] *= p;
	}
    }

/*     NOW CALCULATE THE FIELD COMPONENTS */
/*     (IN CASE OF MULTIPLE INVOCATIONS WITH THE SAME VALUES OF IY AND NM, */
/*      CALCULATIONS START RIGHT HERE): */

L150:
    pp = (float)1. / *r__;
    p = pp;
    k = *nm + 1;
    i__1 = k;
    for (n = 1; n <= i__1; ++n) {
	p *= pp;
	a[n - 1] = p;
	b[n - 1] = p * n;
    }
    p = (float)1.;
    d__ = (float)0.;
    bbr = (float)0.;
    bbt = (float)0.;
    bbf = (float)0.;
    u = *t;
    cf = cos(*f);
    sf = sin(*f);
    c__ = cos(u);
    s = sin(u);
    i__1 = k;
    for (m = 1; m <= i__1; ++m) {
	if (m == 1) {
	    goto L160;
	}
	mm = m - 1;
	w = x;
	x = w * cf + y * sf;
	y = y * cf - w * sf;
	goto L170;
L160:
	x = (float)0.;
	y = (float)1.;
L170:
	q = p;
	z__ = d__;
	bi = (float)0.;
	p2 = (float)0.;
	d2 = (float)0.;
	i__2 = k;
	for (n = m; n <= i__2; ++n) {
	    an = a[n - 1];
	    mn = n * (n - 1) / 2 + m;
	    e = g[mn - 1];
	    hh = h__[mn - 1];
	    w = e * y + hh * x;
	    bbr += b[n - 1] * w * q;
	    bbt -= an * w * z__;
	    if (m == 1) {
		goto L180;
	    }
	    qq = q;
	    if (s < (float)1e-5) {
		qq = z__;
	    }
	    bi += an * (e * x - hh * y) * qq;
L180:
	    xk = rec[mn - 1];
	    dp = c__ * z__ - s * q - xk * d2;
	    pm = c__ * q - xk * p2;
	    d2 = z__;
	    p2 = q;
	    z__ = dp;
	    q = pm;
	}
	d__ = s * d__ + c__ * p;
	p = s * p;
	if (m == 1) {
	    goto L200;
	}
	bi *= mm;
	bbf += bi;
L200:
	;
    }

    *br = bbr;
    *bt = bbt;
    if (s < (float)1e-5) {
	goto L210;
    }
    *bf = bbf / s;
    return 0;
L210:
    if (c__ < (float)0.) {
	bbf = -bbf;
    }
    *bf = bbf;
    return 0;

} /* igrf_ */



/* Subroutine */ int dip_(real *ps, real *x, real *y, real *z__, real *bx, 
	real *by, real *bz)
{
    /* Initialized data */

    static integer m = 0;
    static real psi = (float)5.;

    /* System generated locals */
    real r__1, r__2;


    /* Local variables */
    static real p, q, t, u, v, cps, sps;



/*  CALCULATES GSM COMPONENTS OF A GEODIPOLE FIELD WITH THE DIPOLE MOMENT */
/*  CORRESPONDING TO THE EPOCH OF 2000. */

/* ----INPUT PARAMETERS: */
/*     PS - GEODIPOLE TILT ANGLE IN RADIANS, */
/*     X,Y,Z - GSM COORDINATES IN RE (1 RE = 6371.2 km) */

/* ----OUTPUT PARAMETERS: */
/*     BX,BY,BZ - FIELD COMPONENTS IN GSM SYSTEM, IN NANOTESLA. */

/*  LAST MODIFICATION: JAN. 5, 2001. THE VALUE OF THE DIPOLE MOMENT WAS UPDATED TO 2000. */
/*    AND A "SAVE" STATEMENT HAS BEEN ADDED, TO AVOID POTENTIAL PROBLEMS WITH SOME */
/*    FORTRAN COMPILERS */

/*  WRITTEN BY: N. A. TSYGANENKO */

    if (m == 1 && (r__1 = *ps - psi, dabs(r__1)) < (float)1e-5) {
	goto L1;
    }
    sps = sin(*ps);
    cps = cos(*ps);
    psi = *ps;
    m = 1;
L1:
/* Computing 2nd power */
    r__1 = *x;
    p = r__1 * r__1;
/* Computing 2nd power */
    r__1 = *z__;
    u = r__1 * r__1;
    v = *z__ * (float)3. * *x;
/* Computing 2nd power */
    r__1 = *y;
    t = r__1 * r__1;
/* Computing 5th power */
    r__1 = sqrt(p + t + u), r__2 = r__1, r__1 *= r__1;
    q = (float)30115. / (r__2 * (r__1 * r__1));
    *bx = q * ((t + u - p * (float)2.) * sps - v * cps);
    *by = *y * (float)-3. * q * (*x * sps + *z__ * cps);
    *bz = q * ((p + t - u * (float)2.) * cps - v * sps);
    return 0;
} /* dip_ */


/* Subroutine */ int sun_(integer *iyr, integer *iday, integer *ihour, 
	integer *min__, integer *isec, real *gst, real *slong, real *srasn, 
	real *sdec)
{
    /* Initialized data */

    static real rad = (float)57.295779513;

    /* System generated locals */
    real r__1;
    doublereal d__1;


    /* Local variables */
    static doublereal fday;
    static real cosd, sind, g, t, obliq;
    static doublereal dj;
    static real sc, vl, sob, slp;


/*  CALCULATES FOUR QUANTITIES NECESSARY FOR COORDINATE TRANSFORMATIONS */
/*  WHICH DEPEND ON SUN POSITION (AND, HENCE, ON UNIVERSAL TIME AND SEASON) */

/* -------  INPUT PARAMETERS: */
/*  IYR,IDAY,IHOUR,MIN,ISEC -  YEAR, DAY, AND UNIVERSAL TIME IN HOURS, MINUTES, */
/*    AND SECONDS  (IDAY=1 CORRESPONDS TO JANUARY 1). */

/* -------  OUTPUT PARAMETERS: */
/*  GST - GREENWICH MEAN SIDEREAL TIME, SLONG - LONGITUDE ALONG ECLIPTIC */
/*  SRASN - RIGHT ASCENSION,  SDEC - DECLINATION  OF THE SUN (RADIANS) */
/*  ORIGINAL VERSION OF THIS SUBROUTINE HAS BEEN COMPILED FROM: */
/*  RUSSELL, C.T., COSMIC ELECTRODYNAMICS, 1971, V.2, PP.184-196. */

/*     LAST MODIFICATION:  JAN 5, 2001 (NO ESSENTIAL CHANGES, BUT */
/*     SOME REDUNDANT STATEMENTS TAKEN OUT FROM THE PREVIOUS VERSION) */

/*     ORIGINAL VERSION WRITTEN BY:    Gilbert D. Mead */


    if (*iyr < 1901 || *iyr > 2099) {
	return 0;
    }
    fday = (doublereal) (*ihour * 3600 + *min__ * 60 + *isec) / 86400.;
    dj = (*iyr - 1900) * 365 + (*iyr - 1901) / 4 + *iday - .5 + fday;
    t = dj / (float)36525.;
    d__1 = dj * (float).9856473354 + (float)279.696678;
    vl = fmod(d__1, c_b37);
    d__1 = dj * (float).9856473354 + (float)279.690983 + fday * (float)360. + 
	    (float)180.;
    *gst = fmod(d__1, c_b37) / rad;
    d__1 = dj * (float).985600267 + (float)358.475845;
    g = fmod(d__1, c_b37) / rad;
    *slong = (vl + ((float)1.91946 - t * (float).004789) * sin(g) + sin(g * (
	    float)2.) * (float).020094) / rad;
    if (*slong > (float)6.2831853) {
	*slong += (float)-6.2831853;
    }
    if (*slong < (float)0.) {
	*slong += (float)6.2831853;
    }
    obliq = ((float)23.45229 - t * (float).0130125) / rad;
    sob = sin(obliq);
    slp = *slong - (float)9.924e-5;

/*   THE LAST CONSTANT IS A CORRECTION FOR THE ANGULAR ABERRATION  DUE TO */
/*   THE ORBITAL MOTION OF THE EARTH */

    sind = sob * sin(slp);
/* Computing 2nd power */
    r__1 = sind;
    cosd = sqrt((float)1. - r__1 * r__1);
    sc = sind / cosd;
    *sdec = atan(sc);
    *srasn = (float)3.141592654 - atan2(cos(obliq) / sob * sc, -cos(slp) / 
	    cosd);
    return 0;
} /* sun_ */


/* Subroutine */ int sphcar_(real *r__, real *teta, real *phi, real *x, real *
	y, real *z__, integer *j)
{
    /* System generated locals */
    real r__1, r__2;


    /* Local variables */
    static real sq;


/*   CONVERTS SPHERICAL COORDS INTO CARTESIAN ONES AND VICA VERSA */
/*    (TETA AND PHI IN RADIANS). */

/*                  J &Gt 0            J &Lt 0 */
/* -----INPUT:   J,R,TETA,PHI     J,X,Y,Z */
/* ----OUTPUT:      X,Y,Z        R,TETA,PHI */

/*   LAST MOFIFICATION:  JAN 5, 2001 (NO ESSENTIAL CHANGES, BUT */
/*                        SOME REDUNDANT STATEMENTS TAKEN OUT) */

/*   WRITTEN BY:  N. A. TSYGANENKO */

    if (*j > 0) {
	goto L3;
    }
/* Computing 2nd power */
    r__1 = *x;
/* Computing 2nd power */
    r__2 = *y;
    sq = r__1 * r__1 + r__2 * r__2;
/* Computing 2nd power */
    r__1 = *z__;
    *r__ = sqrt(sq + r__1 * r__1);
    if (sq != (float)0.) {
	goto L2;
    }
    *phi = (float)0.;
    if (*z__ < (float)0.) {
	goto L1;
    }
    *teta = (float)0.;
    return 0;
L1:
    *teta = (float)3.141592654;
    return 0;
L2:
    sq = sqrt(sq);
    *phi = atan2(*y, *x);
    *teta = atan2(sq, *z__);
    if (*phi < (float)0.) {
	*phi += (float)6.28318531;
    }
    return 0;
L3:
    sq = *r__ * sin(*teta);
    *x = sq * cos(*phi);
    *y = sq * sin(*phi);
    *z__ = *r__ * cos(*teta);
    return 0;
} /* sphcar_ */


/* Subroutine */ int bspcar_(real *teta, real *phi, real *br, real *btet, 
	real *bphi, real *bx, real *by, real *bz)
{


    /* Local variables */
    static real c__, s, be, cf, sf;


/*   CALCULATES CARTESIAN FIELD COMPONENTS FROM SPHERICAL ONES */
/* -----INPUT:   TETA,PHI - SPHERICAL ANGLES OF THE POINT IN RADIANS */
/*              BR,BTET,BPHI -  SPHERICAL COMPONENTS OF THE FIELD */
/* -----OUTPUT:  BX,BY,BZ - CARTESIAN COMPONENTS OF THE FIELD */

/*   LAST MOFIFICATION:  JAN 5 2001 (NO ESSENTIAL CHANGES, BUT */
/*                        SOME REDUNDANT STATEMENTS TAKEN OUT) */

/*   WRITTEN BY:  N. A. TSYGANENKO */

    s = sin(*teta);
    c__ = cos(*teta);
    sf = sin(*phi);
    cf = cos(*phi);
    be = *br * s + *btet * c__;
    *bx = be * cf - *bphi * sf;
    *by = be * sf + *bphi * cf;
    *bz = *br * c__ - *btet * s;
    return 0;
} /* bspcar_ */



/* Subroutine */ int recalc_(integer *iyr, integer *iday, integer *ihour, 
	integer *min__, integer *isec)
{
    /* Initialized data */

    static integer iye = 0;
    static integer ide = 0;
    static integer ipr = 0;

    /* System generated locals */
    real r__1, r__2;

 
    /* Local variables */
    static real sdec, t, y, obliq, slong, f1, f2, srasn, s1, s2, s3, y1, y2, 
	    y3, z1, z2, z3, g10, g11, h11, dj, dt, sq, exmagx, exmagy, exmagz,
	     eymagx, eymagy, dy1, dz1, dz2, dz3, dy2, dy3, gst, sqq, sqr;
    extern /* Subroutine */ int sun_(integer *, integer *, integer *, integer 
	    *, integer *, real *, real *, real *, real *);
    static real dip1, dip2, dip3;



/*  PREPARES ELEMENTS OF ROTATION MATRICES FOR TRANSFORMATIONS OF VECTORS BETWEEN */
/*  SEVERAL COORDINATE SYSTEMS, MOST FREQUENTLY USED IN SPACE PHYSICS. */

/*  THIS SUBROUTINE SHOULD BE INVOKED BEFORE USING THE FOLLOWING SUBROUTINES: */
/*         GEOGSM, MAGSM, SMGSM, GSMGSE, GEIGEO. */

/*  THERE IS NO NEED TO REPEATEDLY INVOKE RECALC, IF MULTIPLE CALCULATIONS ARE MADE */
/*    FOR THE SAME DATE AND TIME. */

/* -----INPUT PARAMETERS: */

/*     IYR   -  YEAR NUMBER (FOUR DIGITS) */
/*     IDAY  -  DAY OF YEAR (DAY 1 = JAN 1) */
/*     IHOUR -  HOUR OF DAY (00 TO 23) */
/*     MIN   -  MINUTE OF HOUR (00 TO 59) */
/*     ISEC  -  SECONDS OF MINUTE (00 TO 59) */

/* -----OUTPUT PARAMETERS:   NONE (ALL OUTPUT QUANTITIES ARE PLACED */
/*                                 INTO THE COMMON BLOCK /GEOPACK/) */

/*    OTHER SUBROUTINES CALLED BY THIS ONE: SUN */

/*   ################################################ */
/*   #  WRITTEN BY  N.A. TSYGANENKO ON DEC.1, 1991  # */
/*   ################################################ */

/*    Last modification:  January 5, 2001. */
/*    The code has been modified to accept dates through 2005. */
/*    Also, a "save" statement was added, to avoid potential problems */
/*    with some Fortran compilers. */



    if (*iyr == iye && *iday == ide) {
	goto L5;
    }

/*   IYE AND IDE ARE THE CURRENT VALUES OF YEAR AND DAY NUMBER */

    geopack_1.iy = *iyr;
    ide = *iday;
    if (geopack_1.iy < 1965) {
	geopack_1.iy = 1965;
    }
    if (geopack_1.iy > 2005) {
	geopack_1.iy = 2005;
    }

/*  WE ARE RESTRICTED BY THE INTERVAL 1965-2005, */
/*  FOR WHICH THE IGRF COEFFICIENTS ARE KNOWN; IF IYR IS OUTSIDE THIS INTERVAL */
/*  THE SUBROUTINE PRINTS A WARNING (BUT DOES NOT REPEAT IT AT NEXT INVOCATIONS) */



    if (geopack_1.iy != *iyr && ipr == 0) {
	printf("(\n****RECALC WARNS:  YEAR IS OUT OF INTERVAL 1965-2005: IYR=%d\n CALCULATIONS WILL BE DONE FOR IYR=%d)", (int)*iyr, (int)geopack_1.iy);
    }
    if (geopack_1.iy != *iyr) {
	ipr = 1;
    }
    iye = geopack_1.iy;

/*  LINEAR INTERPOLATION OF THE GEODIPOLE MOMENT COMPONENTS BETWEEN THE */
/*  VALUES FOR THE NEAREST EPOCHS: */

    if (geopack_1.iy < 1970) {
/* 1965-1970 */
	f2 = ((real) geopack_1.iy + (real) (*iday) / (float)365. - (float)
		1965.) / (float)5.;
	f1 = 1. - f2;
	g10 = f1 * (float)30334. + f2 * (float)30220.;
/* HERE G10 HAS OPPOSITE SIGN TO THAT */
	g11 = f1 * (float)-2119. - f2 * (float)2068.;
	h11 = f1 * (float)5776. + f2 * (float)5737.;
    } else if (geopack_1.iy < 1975) {
/* 1970-1975 */
	f2 = ((real) geopack_1.iy + (real) (*iday) / (float)365. - (float)
		1970.) / (float)5.;
	f1 = 1. - f2;
	g10 = f1 * (float)30220. + f2 * (float)30100.;
/* HERE G10 HAS OPPOSITE SIGN TO THAT */
	g11 = f1 * (float)-2068. - f2 * (float)2013.;
	h11 = f1 * (float)5737. + f2 * (float)5675.;
    } else if (geopack_1.iy < 1980) {
/* 1975-1980 */
	f2 = ((doublereal) geopack_1.iy + (doublereal) (*iday) / (float)365. 
		- (float)1975.) / (float)5.;
	f1 = 1. - f2;
	g10 = f1 * (float)30100. + f2 * (float)29992.;
/* HERE G10 HAS OPPOSITE SIGN TO THAT */
	g11 = f1 * (float)-2013. - f2 * (float)1956.;
	h11 = f1 * (float)5675. + f2 * (float)5604.;
    } else if (geopack_1.iy < 1985) {
/* 1980-1985 */
	f2 = ((real) geopack_1.iy + (real) (*iday) / (float)365. - (float)
		1980.) / (float)5.;
	f1 = 1. - f2;
	g10 = f1 * (float)29992. + f2 * (float)29873.;
/* HERE G10 HAS OPPOSITE SIGN TO THAT */
	g11 = f1 * (float)-1956. - f2 * (float)1905.;
	h11 = f1 * (float)5604. + f2 * (float)5500.;
    } else if (geopack_1.iy < 1990) {
/* 1985-1990 */
	f2 = ((real) geopack_1.iy + (real) (*iday) / (float)365. - (float)
		1985.) / (float)5.;
	f1 = 1. - f2;
	g10 = f1 * (float)29873. + f2 * (float)29775.;
/* HERE G10 HAS OPPOSITE SIGN TO THAT */
	g11 = f1 * (float)-1905. - f2 * (float)1848.;
	h11 = f1 * (float)5500. + f2 * (float)5406.;
    } else if (geopack_1.iy < 1995) {
/* 1990-1995 */
	f2 = ((real) geopack_1.iy + (real) (*iday) / (float)365. - (float)
		1990.) / (float)5.;
	f1 = 1. - f2;
	g10 = f1 * (float)29775. + f2 * (float)29682.;
/* HERE G10 HAS OPPOSITE SIGN TO THAT */
	g11 = f1 * (float)-1848. - f2 * (float)1789.;
	h11 = f1 * (float)5406. + f2 * (float)5318.;
    } else if (geopack_1.iy < 2000) {
/* 1995-2000 */
	f2 = ((real) geopack_1.iy + (real) (*iday) / (float)365. - (float)
		1990.) / (float)5.;
	f1 = 1. - f2;
	g10 = f1 * (float)29682. + f2 * (float)29615.;
/* HERE G10 HAS OPPOSITE SIGN TO THAT */
	g11 = f1 * (float)-1789. - f2 * (float)1728.;
	h11 = f1 * (float)5318. + f2 * (float)5186.;
    } else {

/*   LINEAR EXTRAPOLATION BEYOND 2000 BY USING SECULAR VELOCITY COEFFICIENTS: */

/* 2000-2005 */
	dt = (real) geopack_1.iy + (real) (*iday) / (float)366. - (float)2e3;
	g10 = (float)29615. - dt * (float)14.6;
/* HERE G10 HAS OPPOSITE SIGN TO THAT */
	g11 = dt * (float)10.7 - (float)1728.;
	h11 = (float)5186. - dt * (float)22.5;
    }

/*  NOW CALCULATE THE COMPONENTS OF THE UNIT VECTOR EzMAG IN GEO COORD.SYSTEM: */
/*   SIN(TETA0)*COS(LAMBDA0), SIN(TETA0)*SIN(LAMBDA0), AND COS(TETA0) */
/*         ST0 * CL0                ST0 * SL0                CT0 */

/* Computing 2nd power */
    r__1 = g11;
/* Computing 2nd power */
    r__2 = h11;
    sq = r__1 * r__1 + r__2 * r__2;
    sqq = sqrt(sq);
/* Computing 2nd power */
    r__1 = g10;
    sqr = sqrt(r__1 * r__1 + sq);
    geopack_1.sl0 = -h11 / sqq;
    geopack_1.cl0 = -g11 / sqq;
    geopack_1.st0 = sqq / sqr;
    geopack_1.ct0 = g10 / sqr;
    geopack_1.stcl = geopack_1.st0 * geopack_1.cl0;
    geopack_1.stsl = geopack_1.st0 * geopack_1.sl0;
    geopack_1.ctsl = geopack_1.ct0 * geopack_1.sl0;
    geopack_1.ctcl = geopack_1.ct0 * geopack_1.cl0;

/*      THE CALCULATIONS ARE TERMINATED IF ONLY GEO-MAG TRANSFORMATION */
/*       IS TO BE DONE  (IHOUR>24 IS THE AGREED INDICATOR FOR THIS CASE): */

L5:
    if (*ihour > 24) {
	return 0;
    }

    sun_(&geopack_1.iy, iday, ihour, min__, isec, &gst, &slong, &srasn, &sdec)
	    ;

/*  S1,S2, AND S3 ARE THE COMPONENTS OF THE UNIT VECTOR EXGSM=EXGSE IN THE */
/*   SYSTEM GEI POINTING FROM THE EARTH'S CENTER TO THE SUN: */

    s1 = cos(srasn) * cos(sdec);
    s2 = sin(srasn) * cos(sdec);
    s3 = sin(sdec);
    geopack_1.cgst = cos(gst);
    geopack_1.sgst = sin(gst);

/*  DIP1, DIP2, AND DIP3 ARE THE COMPONENTS OF THE UNIT VECTOR EZSM=EZMAG */
/*   IN THE SYSTEM GEI: */

    dip1 = geopack_1.stcl * geopack_1.cgst - geopack_1.stsl * geopack_1.sgst;
    dip2 = geopack_1.stcl * geopack_1.sgst + geopack_1.stsl * geopack_1.cgst;
    dip3 = geopack_1.ct0;

/*  NOW CALCULATE THE COMPONENTS OF THE UNIT VECTOR EYGSM IN THE SYSTEM GEI */
/*   BY TAKING THE VECTOR PRODUCT D x S AND NORMALIZING IT TO UNIT LENGTH: */

    y1 = dip2 * s3 - dip3 * s2;
    y2 = dip3 * s1 - dip1 * s3;
    y3 = dip1 * s2 - dip2 * s1;
    y = sqrt(y1 * y1 + y2 * y2 + y3 * y3);
    y1 /= y;
    y2 /= y;
    y3 /= y;

/*   THEN IN THE GEI SYSTEM THE UNIT VECTOR Z = EZGSM = EXGSM x EYGSM = S x Y */
/*    HAS THE COMPONENTS: */

    z1 = s2 * y3 - s3 * y2;
    z2 = s3 * y1 - s1 * y3;
    z3 = s1 * y2 - s2 * y1;

/*    THE VECTOR EZGSE (HERE DZ) IN GEI HAS THE COMPONENTS (0,-SIN(DELTA), */
/*     COS(DELTA)) = (0.,-0.397823,0.917462); HERE DELTA = 23.44214 DEG FOR */
/*   THE EPOCH 1978 (SEE THE BOOK BY GUREVICH OR OTHER ASTRONOMICAL HANDBOOKS). */
/*    HERE THE MOST ACCURATE TIME-DEPENDENT FORMULA IS USED: */

    dj = (real) ((geopack_1.iy - 1900) * 365 + (geopack_1.iy - 1901) / 4 + *
	    iday) - (float).5 + (real) (*ihour * 3600 + *min__ * 60 + *isec) /
	     (float)86400.;
    t = dj / (float)36525.;
    obliq = ((float)23.45229 - t * (float).0130125) / (float)57.2957795;
    dz1 = (float)0.;
    dz2 = -sin(obliq);
    dz3 = cos(obliq);

/*  THEN THE UNIT VECTOR EYGSE IN GEI SYSTEM IS THE VECTOR PRODUCT DZ x S : */

    dy1 = dz2 * s3 - dz3 * s2;
    dy2 = dz3 * s1 - dz1 * s3;
    dy3 = dz1 * s2 - dz2 * s1;

/*   THE ELEMENTS OF THE MATRIX GSE TO GSM ARE THE SCALAR PRODUCTS: */
/*   CHI=EM22=(EYGSM,EYGSE), SHI=EM23=(EYGSM,EZGSE), EM32=(EZGSM,EYGSE)=-EM23, */
/*     AND EM33=(EZGSM,EZGSE)=EM22 */

    geopack_1.chi = y1 * dy1 + y2 * dy2 + y3 * dy3;
    geopack_1.shi = y1 * dz1 + y2 * dz2 + y3 * dz3;
    geopack_1.hi = asin(geopack_1.shi);

/*    TILT ANGLE: PSI=ARCSIN(DIP,EXGSM) */

    geopack_1.sps = dip1 * s1 + dip2 * s2 + dip3 * s3;
/* Computing 2nd power */
    r__1 = geopack_1.sps;
    geopack_1.cps = sqrt((float)1. - r__1 * r__1);
    geopack_1.psi = asin(geopack_1.sps);

/*    THE ELEMENTS OF THE MATRIX MAG TO SM ARE THE SCALAR PRODUCTS: */
/* CFI=GM22=(EYSM,EYMAG), SFI=GM23=(EYSM,EXMAG); THEY CAN BE DERIVED AS FOLLOWS: */

/* IN GEO THE VECTORS EXMAG AND EYMAG HAVE THE COMPONENTS (CT0*CL0,CT0*SL0,-ST0) */
/*  AND (-SL0,CL0,0), RESPECTIVELY.    HENCE, IN GEI THE COMPONENTS ARE: */
/*  EXMAG:    CT0*CL0*COS(GST)-CT0*SL0*SIN(GST) */
/*            CT0*CL0*SIN(GST)+CT0*SL0*COS(GST) */
/*            -ST0 */
/*  EYMAG:    -SL0*COS(GST)-CL0*SIN(GST) */
/*            -SL0*SIN(GST)+CL0*COS(GST) */
/*             0 */
/*  THE COMPONENTS OF EYSM IN GEI WERE FOUND ABOVE AS Y1, Y2, AND Y3; */
/*  NOW WE ONLY HAVE TO COMBINE THE QUANTITIES INTO SCALAR PRODUCTS: */

    exmagx = geopack_1.ct0 * (geopack_1.cl0 * geopack_1.cgst - geopack_1.sl0 *
	     geopack_1.sgst);
    exmagy = geopack_1.ct0 * (geopack_1.cl0 * geopack_1.sgst + geopack_1.sl0 *
	     geopack_1.cgst);
    exmagz = -geopack_1.st0;
    eymagx = -(geopack_1.sl0 * geopack_1.cgst + geopack_1.cl0 * 
	    geopack_1.sgst);
    eymagy = -(geopack_1.sl0 * geopack_1.sgst - geopack_1.cl0 * 
	    geopack_1.cgst);
    geopack_1.cfi = y1 * eymagx + y2 * eymagy;
    geopack_1.sfi = y1 * exmagx + y2 * exmagy + y3 * exmagz;

    geopack_1.xmut = (atan2(geopack_1.sfi, geopack_1.cfi) + (float)
	    3.1415926536) * (float)3.8197186342;

/*  THE ELEMENTS OF THE MATRIX GEO TO GSM ARE THE SCALAR PRODUCTS: */

/*   A11=(EXGEO,EXGSM), A12=(EYGEO,EXGSM), A13=(EZGEO,EXGSM), */
/*   A21=(EXGEO,EYGSM), A22=(EYGEO,EYGSM), A23=(EZGEO,EYGSM), */
/*   A31=(EXGEO,EZGSM), A32=(EYGEO,EZGSM), A33=(EZGEO,EZGSM), */

/*   ALL THE UNIT VECTORS IN BRACKETS ARE ALREADY DEFINED IN GEI: */

/*  EXGEO=(CGST,SGST,0), EYGEO=(-SGST,CGST,0), EZGEO=(0,0,1) */
/*  EXGSM=(S1,S2,S3),  EYGSM=(Y1,Y2,Y3),   EZGSM=(Z1,Z2,Z3) */
/*                                                           AND  THEREFORE: */

    geopack_1.a11 = s1 * geopack_1.cgst + s2 * geopack_1.sgst;
    geopack_1.a12 = -s1 * geopack_1.sgst + s2 * geopack_1.cgst;
    geopack_1.a13 = s3;
    geopack_1.a21 = y1 * geopack_1.cgst + y2 * geopack_1.sgst;
    geopack_1.a22 = -y1 * geopack_1.sgst + y2 * geopack_1.cgst;
    geopack_1.a23 = y3;
    geopack_1.a31 = z1 * geopack_1.cgst + z2 * geopack_1.sgst;
    geopack_1.a32 = -z1 * geopack_1.sgst + z2 * geopack_1.cgst;
    geopack_1.a33 = z3;

    return 0;
} /* recalc_ */


/* Subroutine */ int geomag_(real *xgeo, real *ygeo, real *zgeo, real *xmag, 
	real *ymag, real *zmag, integer *j, integer *iyr)
{
    /* Initialized data */

    static integer ii = 1;

    extern /* Subroutine */ int recalc_(integer *, integer *, integer *, 
	    integer *, integer *);


/*    CONVERTS GEOGRAPHIC (GEO) TO DIPOLE (MAG) COORDINATES OR VICA VERSA. */
/*    IYR IS YEAR NUMBER (FOUR DIGITS). */

/*                           J &Gt  0                J &Lt 0 */
/* -----INPUT:  J,XGEO,YGEO,ZGEO,IYR   J,XMAG,YMAG,ZMAG,IYR */
/* -----OUTPUT:    XMAG,YMAG,ZMAG        XGEO,YGEO,ZGEO */

/*   OTHER SUBROUTINES CALLED BY THIS ONE:  RECALC */

/*   LAST MOFIFICATION:  JAN 5, 2001 (NO ESSENTIAL CHANGES, BUT */
/*                         SOME REDUNDANT STATEMENTS TAKEN OUT) */

/*   WRITTEN BY:  N. A. TSYGANENKO */


    if (*iyr == ii) {
	goto L1;
    }
    ii = *iyr;
    recalc_(&ii, &c__0, &c__25, &c__0, &c__0);
L1:
    if (*j < 0) {
	goto L2;
    }
    *xmag = *xgeo * geopack_2.ctcl + *ygeo * geopack_2.ctsl - *zgeo * 
	    geopack_2.st0;
    *ymag = *ygeo * geopack_2.cl0 - *xgeo * geopack_2.sl0;
    *zmag = *xgeo * geopack_2.stcl + *ygeo * geopack_2.stsl + *zgeo * 
	    geopack_2.ct0;
    return 0;
L2:
    *xgeo = *xmag * geopack_2.ctcl - *ymag * geopack_2.sl0 + *zmag * 
	    geopack_2.stcl;
    *ygeo = *xmag * geopack_2.ctsl + *ymag * geopack_2.cl0 + *zmag * 
	    geopack_2.stsl;
    *zgeo = *zmag * geopack_2.ct0 - *xmag * geopack_2.st0;
    return 0;
} /* geomag_ */



/* Subroutine */ int geigeo_(real *xgei, real *ygei, real *zgei, real *xgeo, 
	real *ygeo, real *zgeo, integer *j)
{

/*   CONVERTS EQUATORIAL INERTIAL (GEI) TO GEOGRAPHICAL (GEO) COORDS */
/*   OR VICA VERSA. */
/*                    J &Gt 0                J &Lt 0 */
/* ----INPUT:  J,XGEI,YGEI,ZGEI    J,XGEO,YGEO,ZGEO */
/* ----OUTPUT:   XGEO,YGEO,ZGEO      XGEI,YGEI,ZGEI */

/*  ATTENTION:  SUBROUTINE  RECALC  MUST BE INVOKED BEFORE GEIGEO IN TWO CASES: */
/*     /A/  BEFORE THE FIRST INVOCATION OF GEIGEO */
/*     /B/  IF THE CURRENT VALUES OF IYEAR,IDAY,IHOUR,MIN,ISEC HAVE BEEN CHANGED */

/*     LAST MODIFICATION:  JAN 5, 2001 (NO ESSENTIAL CHANGES, BUT */
/*                         SOME REDUNDANT STATEMENTS TAKEN OUT) */
/*     WRITTEN BY:  N. A. TSYGANENKO */


    if (*j < 0) {
	goto L1;
    }
    *xgeo = *xgei * geopack_3.cgst + *ygei * geopack_3.sgst;
    *ygeo = *ygei * geopack_3.cgst - *xgei * geopack_3.sgst;
    *zgeo = *zgei;
    return 0;
L1:
    *xgei = *xgeo * geopack_3.cgst - *ygeo * geopack_3.sgst;
    *ygei = *ygeo * geopack_3.cgst + *xgeo * geopack_3.sgst;
    *zgei = *zgeo;
    return 0;
} /* geigeo_ */



/* Subroutine */ int magsm_(real *xmag, real *ymag, real *zmag, real *xsm, 
	real *ysm, real *zsm, integer *j)
{

/*  CONVERTS DIPOLE (MAG) TO SOLAR MAGNETIC (SM) COORDINATES OR VICA VERSA */

/*                    J &Gt 0              J &Lt 0 */
/* ----INPUT: J,XMAG,YMAG,ZMAG     J,XSM,YSM,ZSM */
/* ----OUTPUT:    XSM,YSM,ZSM       XMAG,YMAG,ZMAG */

/*  ATTENTION:  SUBROUTINE  RECALC  MUST BE INVOKED BEFORE MAGSM IN TWO CASES: */
/*     /A/  BEFORE THE FIRST INVOCATION OF MAGSM */
/*     /B/  IF THE VALUES OF IYEAR,IDAY,IHOUR,MIN,ISEC HAVE BEEN CHANGED */

/*     LAST MODIFICATION:  JAN 5, 2001 (NO ESSENTIAL CHANGES, BUT */
/*                            SOME REDUNDANT STATEMENTS TAKEN OUT) */

/*     WRITTEN BY:  N. A. TSYGANENKO */


    if (*j < 0) {
	goto L1;
    }
    *xsm = *xmag * geopack_4.cfi - *ymag * geopack_4.sfi;
    *ysm = *xmag * geopack_4.sfi + *ymag * geopack_4.cfi;
    *zsm = *zmag;
    return 0;
L1:
    *xmag = *xsm * geopack_4.cfi + *ysm * geopack_4.sfi;
    *ymag = *ysm * geopack_4.cfi - *xsm * geopack_4.sfi;
    *zmag = *zsm;
    return 0;
} /* magsm_ */


/* Subroutine */ int gsmgse_(real *xgsm, real *ygsm, real *zgsm, real *xgse, 
	real *ygse, real *zgse, integer *j)
{

/* CONVERTS GEOCENTRIC SOLAR MAGNETOSPHERIC (GSM) COORDS TO SOLAR ECLIPTIC (GSE) ONES */
/*   OR VICA VERSA. */
/*                    J &Gt 0                J &Lt 0 */
/* -----INPUT: J,XGSM,YGSM,ZGSM    J,XGSE,YGSE,ZGSE */
/* ----OUTPUT:   XGSE,YGSE,ZGSE      XGSM,YGSM,ZGSM */

/*  ATTENTION:  SUBROUTINE  RECALC  MUST BE INVOKED BEFORE GSMGSE IN TWO CASES: */
/*     /A/  BEFORE THE FIRST INVOCATION OF GSMGSE */
/*     /B/  IF THE VALUES OF IYEAR,IDAY,IHOUR,MIN,ISEC HAVE BEEN CHANGED */

/*     LAST MODIFICATION:  JAN 5, 2001  (NO ESSENTIAL CHANGES, BUT */
/*                             SOME REDUNDANT STATEMENTS TAKEN OUT) */

/*     WRITTEN BY:  N. A. TSYGANENKO */


    if (*j < 0) {
	goto L1;
    }
    *xgse = *xgsm;
    *ygse = *ygsm * geopack_5.chi - *zgsm * geopack_5.shi;
    *zgse = *ygsm * geopack_5.shi + *zgsm * geopack_5.chi;
    return 0;
L1:
    *xgsm = *xgse;
    *ygsm = *ygse * geopack_5.chi + *zgse * geopack_5.shi;
    *zgsm = *zgse * geopack_5.chi - *ygse * geopack_5.shi;
    return 0;
} /* gsmgse_ */


/* Subroutine */ int smgsm_(real *xsm, real *ysm, real *zsm, real *xgsm, real 
	*ygsm, real *zgsm, integer *j)
{

/* CONVERTS SOLAR MAGNETIC (SM) TO GEOCENTRIC SOLAR MAGNETOSPHERIC */
/*   (GSM) COORDINATES OR VICA VERSA. */
/*                  J &Gt 0                 J &Lt 0 */
/* -----INPUT: J,XSM,YSM,ZSM        J,XGSM,YGSM,ZGSM */
/* ----OUTPUT:  XGSM,YGSM,ZGSM       XSM,YSM,ZSM */

/*  ATTENTION:  SUBROUTINE  RECALC  MUST BE INVOKED BEFORE SMGSM IN TWO CASES: */
/*     /A/  BEFORE THE FIRST INVOCATION OF SMGSM */
/*     /B/  IF THE VALUES OF IYEAR,IDAY,IHOUR,MIN,ISEC HAVE BEEN CHANGED */

/*     LAST MODIFICATION:  JAN 5, 2001  (NO ESSENTIAL CHANGES, BUT */
/*                             SOME REDUNDANT STATEMENTS TAKEN OUT) */

/*     WRITTEN BY:  N. A. TSYGANENKO */

    if (*j < 0) {
	goto L1;
    }
    *xgsm = *xsm * geopack_6.cps + *zsm * geopack_6.sps;
    *ygsm = *ysm;
    *zgsm = *zsm * geopack_6.cps - *xsm * geopack_6.sps;
    return 0;
L1:
    *xsm = *xgsm * geopack_6.cps - *zgsm * geopack_6.sps;
    *ysm = *ygsm;
    *zsm = *xgsm * geopack_6.sps + *zgsm * geopack_6.cps;
    return 0;
} /* smgsm_ */


/* Subroutine */ int geogsm_(real *xgeo, real *ygeo, real *zgeo, real *xgsm, 
	real *ygsm, real *zgsm, integer *j)
{

/* CONVERTS GEOGRAPHIC (GEO) TO SOLAR MAGNETOSPHERIC (SM) COORDINATES OR VICA VERSA. */

/*                   J &Gt 0                   J &Lt 0 */
/* ----- INPUT:  J,XGEO,YGEO,ZGEO    J,XGSM,YGSM,ZGSM */
/* ---- OUTPUT:    XGSM,YGSM,ZGSM      XGEO,YGEO,ZGEO */

/*  ATTENTION:  SUBROUTINE  RECALC  MUST BE INVOKED BEFORE GEOGSM IN TWO CASES: */
/*     /A/  BEFORE THE FIRST INVOCATION OF GEOGSM */
/*     /B/  IF THE VALUES OF IYEAR,IDAY,IHOUR,MIN,ISEC  HAVE BEEN CHANGED */

/*     LAST MODIFICATION:  JAN 5, 2001 (NO ESSENTIAL CHANGES, BUT */
/*                            SOME REDUNDANT STATEMENTS TAKEN OUT) */

/*     WRITTEN BY:  N. A. TSYGANENKO */


    if (*j < 0) {
	goto L1;
    }
    *xgsm = geopack_7.a11 * *xgeo + geopack_7.a12 * *ygeo + geopack_7.a13 * *
	    zgeo;
    *ygsm = geopack_7.a21 * *xgeo + geopack_7.a22 * *ygeo + geopack_7.a23 * *
	    zgeo;
    *zgsm = geopack_7.a31 * *xgeo + geopack_7.a32 * *ygeo + geopack_7.a33 * *
	    zgeo;
    return 0;
L1:
    *xgeo = geopack_7.a11 * *xgsm + geopack_7.a21 * *ygsm + geopack_7.a31 * *
	    zgsm;
    *ygeo = geopack_7.a12 * *xgsm + geopack_7.a22 * *ygsm + geopack_7.a32 * *
	    zgsm;
    *zgeo = geopack_7.a13 * *xgsm + geopack_7.a23 * *ygsm + geopack_7.a33 * *
	    zgsm;
    return 0;
} /* geogsm_ */


/* Subroutine */ int rhand_(real *x, real *y, real *z__, real *r1, real *r2, 
	real *r3, integer *iopt, real *parmod, S_fp exname)
{
    /* System generated locals */
    real r__1, r__2, r__3;


    /* Local variables */
    extern /* Subroutine */ int igrf_(integer *, integer *, real *, real *, 
	    real *, real *, real *, real *);
    static real b, f, r__, t, bf, br, bt, bx, by, bz, fx, xg, yg, zg, fy, fz, 
	    hx, hy, hz;
    extern /* Subroutine */ int bspcar_(real *, real *, real *, real *, real *
	    , real *, real *, real *), sphcar_(real *, real *, real *, real *,
	     real *, real *, integer *), geogsm_(real *, real *, real *, real 
	    *, real *, real *, integer *), dip_(real *, real *, real *, real *
	    , real *, real *, real *);


/*  COMPUTES RIGHT HAND EXPRESSIONS IN THE GEOMAGNETIC FIELD LINE EQUATION */
/*      (a subsidiary subroutine for the subr. STEP) */

/*     LAST MODIFICATION:  JAN 5, 2001 (NO ESSENTIAL CHANGES, BUT */
/*                            SOME REDUNDANT STATEMENTS TAKEN OUT) */

/*     WRITTEN BY:  N. A. TSYGANENKO */


    /* Parameter adjustments */
    --parmod;

    /* Function Body */
    (*exname)(iopt, &parmod[1], &geopack_8.psi, x, y, z__, &bx, &by, &bz);
    if (geopack_8.k == 0) {
	goto L1;
    }
    geogsm_(&xg, &yg, &zg, x, y, z__, &c_n1);
    sphcar_(&r__, &t, &f, &xg, &yg, &zg, &c_n1);
    igrf_(&geopack_8.iy, &geopack_8.k, &r__, &t, &f, &br, &bt, &bf);
    bspcar_(&t, &f, &br, &bt, &bf, &fx, &fy, &fz);
    geogsm_(&fx, &fy, &fz, &hx, &hy, &hz, &c__1);
    goto L2;
L1:
    dip_(&geopack_8.psi, x, y, z__, &hx, &hy, &hz);
L2:
    bx += hx;
    by += hy;
    bz += hz;
/* Computing 2nd power */
    r__1 = bx;
/* Computing 2nd power */
    r__2 = by;
/* Computing 2nd power */
    r__3 = bz;
    b = geopack_8.ds3 / sqrt(r__1 * r__1 + r__2 * r__2 + r__3 * r__3);
    *r1 = bx * b;
    *r2 = by * b;
    *r3 = bz * b;
    return 0;
} /* rhand_ */


/* Subroutine */ int step_(integer *n, real *x, real *y, real *z__, real *ds, 
	real *errin, integer *iopt, real *parmod, S_fp exname)
{
    /* System generated locals */
    real r__1, r__2, r__3;

    /* Local variables */
    extern /* Subroutine */ int rhand_(real *, real *, real *, real *, real *,
	     real *, integer *, real *, S_fp);
    static real r11, r12, r13, r21, r22, r23, r31, r32, r33, r41, r42, r43, 
	    r51, r52, r53, errcur;


/* RE-CALCULATES COORDS X,Y,Z FOR ONE STEP ALONG FIELD LINE. N IS MAXIMUM */
/* ORDER OF HARMONICS IN MAIN FIELD EXPANSION, DS IS STEP SIZE, ERRIN IS */
/* PERMISSIBLE ERROR VALUE, IOPT AND EXNAME - SEE COMMENTS TO SUBROUTINE TRACE */
/*  ALL THE PARAMETERS ARE INPUT ONES; OUTPUT IS THE RENEWED TRIPLET X,Y,Z */

/*     LAST MODIFICATION:  JAN 5, 2001 (NO ESSENTIAL CHANGES, BUT */
/*                            SOME REDUNDANT STATEMENTS TAKEN OUT) */

/*     WRITTEN BY:  N. A. TSYGANENKO */


    /* Parameter adjustments */
    --parmod;

    /* Function Body */
    geopack_9.k = *n;
L1:
    geopack_9.ds3 = -(*ds) / (float)3.;
    rhand_(x, y, z__, &r11, &r12, &r13, iopt, &parmod[1], (S_fp)exname);
    r__1 = *x + r11;
    r__2 = *y + r12;
    r__3 = *z__ + r13;
    rhand_(&r__1, &r__2, &r__3, &r21, &r22, &r23, iopt, &parmod[1], (S_fp)
	    exname);
    r__1 = *x + (r11 + r21) * (float).5;
    r__2 = *y + (r12 + r22) * (float).5;
    r__3 = *z__ + (r13 + r23) * (float).5;
    rhand_(&r__1, &r__2, &r__3, &r31, &r32, &r33, iopt, &parmod[1], (S_fp)
	    exname);
    r__1 = *x + (r11 + r31 * (float)3.) * (float).375;
    r__2 = *y + (r12 + r32 * (float)3.) * (float).375;
    r__3 = *z__ + (r13 + r33 * (float)3.) * (float).375;
    rhand_(&r__1, &r__2, &r__3, &r41, &r42, &r43, iopt, &parmod[1], (S_fp)
	    exname);
    r__1 = *x + (r11 - r31 * (float)3. + r41 * (float)4.) * (float)1.5;
    r__2 = *y + (r12 - r32 * (float)3. + r42 * (float)4.) * (float)1.5;
    r__3 = *z__ + (r13 - r33 * (float)3. + r43 * (float)4.) * (float)1.5;
    rhand_(&r__1, &r__2, &r__3, &r51, &r52, &r53, iopt, &parmod[1], (S_fp)
	    exname);
    errcur = (r__1 = r11 - r31 * (float)4.5 + r41 * (float)4. - r51 * (float)
	    .5, dabs(r__1)) + (r__2 = r12 - r32 * (float)4.5 + r42 * (float)
	    4. - r52 * (float).5, dabs(r__2)) + (r__3 = r13 - r33 * (float)
	    4.5 + r43 * (float)4. - r53 * (float).5, dabs(r__3));
    if (errcur < *errin) {
	goto L2;
    }
    *ds *= (float).5;
    goto L1;
L2:
    *x += (r11 + r41 * (float)4. + r51) * (float).5;
    *y += (r12 + r42 * (float)4. + r52) * (float).5;
    *z__ += (r13 + r43 * (float)4. + r53) * (float).5;
    if (errcur < *errin * (float).04 && dabs(*ds) < (float)1.33) {
	*ds *= (float)1.5;
    }
    return 0;
} /* step_ */


/* Subroutine */ int trace_(real *xi, real *yi, real *zi, real *dir, real *
	rlim, real *r0, integer *iharm, integer *np, integer *iopt, real *
	parmod, S_fp exname, real *xf, real *yf, real *zf, real *xx, real *yy,
	 real *zz, integer *l)
{
 
    /* System generated locals */
    integer i__1;
    real r__1, r__2, r__3;

    /* Builtin functions */
    double r_sign(real *, real *);

    /* Local variables */
    extern /* Subroutine */ int step_(integer *, real *, real *, real *, real 
	    *, real *, integer *, real *, S_fp);
    static integer i__, j;
    static real r__, x, y, z__;
    extern /* Subroutine */ int rhand_(real *, real *, real *, real *, real *,
	     real *, integer *, real *, S_fp);
    static real r1, r2, r3, ad, fc, al, ds, rr, xr, yr, zr, err, ryz;





/*   TRACES A FIELD LINE FROM AN ARBITRARY POINT OF SPACE TO THE EARTH'S */
/*   SURFACE OR TO A MODEL LIMITING BOUNDARY. */

/* ------------- INPUT PARAMETERS: */

/*   XI,YI,ZI - GSM COORDS OF INITIAL POINT (IN EARTH RADII), */

/*   DIR - SIGN OF TRACING DIRECTION: IF DIR=1. THEN ANTIPARALLEL TO */
/*     B VECTOR (E.G. FROM NORTHERN TO SOUTHERN CONJUGATE POINT), */
/*     AND IF DIR=-1. THEN PARALLEL TO B. */

/*   R0 -  RADIUS OF A SPHERE (IN RE) FOR WHICH FOOTPOINT POINT COORDINATES */
/*     XF,YF,ZF  ARE TO BE CALCULATED. */

/*   RLIM - UPPER LIMIT OF THE GEOCENTRIC DISTANCE, WHERE THE TRACING IS TERMINATED. */

/*   IHARM - THE HIGHEST ORDER OF SPHERICAL HARMONICS IN THE MAIN FIELD EXPANSION, */
/*     THIS PARAMETER DEPENDS ON A VERSION OF THE MAIN GEOMAGNETIC FIELD MODEL. */
/*     THE SUBROUTINE IGRF INCLUDED IN THIS PACKAGE HAS IHARM=10. */
/*     IF THE MAIN FIELD CAN BE ASSUMED PURELY DIPOLAR, THEN TAKE IHARM=0 */
/*     AND SPECIFY A VALUE OF THE GEODIPOLE TILT ANGLE PSI (IN RADIANS) */
/*     IN THE 16-TH ELEMENT OF THE COMMON BLOCK /GEOPACK/ BEFORE INVOKING TRACE. */
/*     OTHERWISE INVOKE  RECALC  BEFORE USING  TRACE. */

/*   NP - UPPER ESTIMATE OF THE NUMBER OF STEPS ALONG A FIELD LINE */
/*     (IN MOST CASES, NP=500 IS SUFFICIENT). */

/*   IOPT - A MODEL INDEX; CAN BE USED FOR SPECIFYING AN OPTION OF THE EXTERNAL FIELD */
/*       MODEL (E.G., INTERVAL OF THE KP-INDEX). ALTERNATIVELY, ONE CAN USE THE ARRAY */
/*       PARMOD FOR THAT PURPOSE (SEE BELOW); IN THAT CASE IOPT CAN BE JUST IGNORED. */

/*    PARMOD -  A 10-ELEMENT ARRAY CONTAINING MODEL PARAMETERS, NEEDED FOR A UNIQUE */
/*      SPECIFICATION OF THE EXTERNAL FIELD. THE CONCRETE MEANING OF THE COMPONENTS */
/*      OF PARMOD DEPENDS ON A SPECIFIC VERSION OF THE EXTERNAL FIELD MODEL. */

/*    EXNAME - NAME OF A SUBROUTINE PROVIDING COMPONENTS OF THE EXTERNAL MAGNETIC FIELD. */

/* -------------- OUTPUT PARAMETERS: */

/*   XF,YF,ZF - GSM COORDS OF THE LAST CALCULATED POINT OF A FIELD LINE */
/*   XX,YY,ZZ - ARRAYS, CONTAINING COORDS OF FIELD LINE POINTS. THEIR SIZE SHOULD BE */
/*      NOT LESS THAN  NP. */
/*   L - ACTUAL NUMBER OF THE CALCULATED FIELD LINE POINTS. IF L EXCEEDS NP, THE TRACING */
/*     TERMINATES, AND A WARNING IS DISPLAYED. */


/*     LAST MODIFICATION:  JAN 5, 2001 (NO ESSENTIAL CHANGES) */

/*     WRITTEN BY:  N. A. TSYGANENKO */

    /* Parameter adjustments */
    --zz;
    --yy;
    --xx;
    --parmod;

    /* Function Body */
    j = *iharm;
    err = (float)5e-4;
    *l = 0;
    ds = *dir * (float).5;
    x = *xi;
    y = *yi;
    z__ = *zi;
    geopack_10.dd = *dir;
    geopack_10.k1 = *iharm;
    al = (float)0.;
    rhand_(&x, &y, &z__, &r1, &r2, &r3, iopt, &parmod[1], (S_fp)exname);
    r__1 = x * r1 + y * r2 + z__ * r3;
    ad = r_sign(&c_b78, &r__1);
/* Computing 2nd power */
    r__1 = x;
/* Computing 2nd power */
    r__2 = y;
/* Computing 2nd power */
    r__3 = z__;
    rr = sqrt(r__1 * r__1 + r__2 * r__2 + r__3 * r__3) + ad;
L1:
    ++(*l);
    if (*l > *np) {
	goto L7;
    }
    xx[*l] = x;
    yy[*l] = y;
    zz[*l] = z__;
/* Computing 2nd power */
    r__1 = y;
/* Computing 2nd power */
    r__2 = z__;
    ryz = r__1 * r__1 + r__2 * r__2;
/* Computing 2nd power */
    r__1 = x;
    r2 = r__1 * r__1 + ryz;
    r__ = sqrt(r2);
    if (r__ > *rlim || ryz > (float)1600. || x > (float)20.) {
	goto L8;
    }
    if (r__ < *r0 && rr > r__) {
	goto L6;
    }
    if (r__ >= rr) {
	goto L5;
    }
    if (r__ > (float)5.) {
	goto L5;
    }
    if (r__ >= (float)3.) {
	goto L3;
    }
    fc = (float).2;
    if (r__ - *r0 < (float).05) {
	fc = (float).05;
    }
    al = fc * (r__ - *r0 + (float).2);
    ds = *dir * al;
    goto L4;
L3:
    ds = *dir;
    al = (float)1.;
L4:
    xr = x;
    yr = y;
    zr = z__;
L5:
    rr = r__;
    if (*iharm != 0) {
	j = (int) ((float)20. / (r__ - al) + 1);
    }
    if (j > *iharm) {
	j = *iharm;
    }
    step_(&j, &x, &y, &z__, &ds, &err, iopt, &parmod[1], (S_fp)exname);
    goto L1;
L6:
    r1 = (*r0 - r__) / (rr - r__);
    x -= (x - xr) * r1;
    y -= (y - yr) * r1;
    z__ -= (z__ - zr) * r1;
    goto L8;
L7:
    printf("(\n**** COMPUTATIONS IN THE SUBROUTINE TRACE ARE TERMINATED: NP IS TOO SMALL ****\n)");
    *l = *np;
    return 0;
L8:
    *xf = x;
    *yf = y;
    *zf = z__;
    i__1 = *np;
    for (i__ = *l; i__ <= i__1; ++i__) {
	xx[i__] = *xf;
	yy[i__] = *yf;
/* L9: */
	zz[i__] = *zf;
    }
    return 0;
} /* trace_ */

#ifdef __cplusplus
	}
#endif
