//
//  DvString.cc
//
//  DVOS - string class 
//

#include "DvObj.h"
#include "DvString.h"

  int DvString::dblPrecision=16; // static used for all strings when setting from double

  int DvString::getDblPrecision(){
	return dblPrecision;
  }
	
  void DvString::setDblPrecision(int prec){
	dblPrecision = prec;
  }
	
  void DvString::set(double value){
	std::ostringstream buffer;
  	buffer.precision(dblPrecision);
	buffer << value;
	
	*this = buffer.str();  	
  }

  void DvString::append(double d, const char * spacer){
    *this += spacer;
	ostringstream tmpStr(ostringstream::ate);
	tmpStr.precision(dblPrecision);
	
	tmpStr << d;

  	*this += tmpStr.str();
  }
