
#include "qcalc.h"
#include "qwui.h"

using namespace QSAS;

extern qwuiWindow* qsasWindow;



void QcalcListView::mouseReleaseEvent( QMouseEvent *event )
{
	// called if mouse pressed and released (i.e. not held down and moved) and
	// after contentsMousePressEvent
   if(QuSlotDebug())
  	printf("QcalcListView::mouseReleaseEvent %ld\n", (long)this);

	QTreeView::mouseReleaseEvent( event );
	
//	if(this->underMouse()) {
		if(  event->modifiers() != Qt::ControlModifier && event->modifiers() != Qt::ShiftModifier)
		{
			// not doing multiple selection, so show tab on mouse up
			QcalcItem * current_item = dynamic_cast<QcalcItem *>(calcModel()->itemFromIndex(currentIndex()) );
			if(current_item != NULL ) 
			{
				this->showTab(current_item->m_pcalcTab);
			}
		}
//	}

}




