#include "qcalc.h"
#include "qwui.h"


using namespace QSAS;

extern qwuiWindow* qsasWindow;

void QcalcWindow::launchManual()
{

 if ( QuSlotDebug() )
 {
    printf( "QcalcWindow::launchManual %ld\n", (long)this );
	fflush(stdout);
 }

   qsasWindow->help_window->manEntry( "QSAS_help_index.html" );

}

void QcalcWindow::launchManExport(){

 if  ( QuSlotDebug() )
 {
	printf("QcalcWindow::launchManExport %ld\n", (long)this);
	fflush(stdout);
 }

   qsasWindow->help_window->manEntry( "QSAS_data_handling.html" );
}

void QcalcWindow::launchManJoin()
{

 if  ( QuSlotDebug() )
 {
    printf( "QcalcWindow::launchManJoin %ld\n", (long)this );
	fflush(stdout);
  }

   qsasWindow->help_window->manEntry( "QSAS_calculator.html" /*"QSAS_analysis.html"*/ );

}

void QcalcWindow::launchVersion(){

 if ( QuSlotDebug() )
 {
	printf( "DirectImportWindow::launchVersion %ld\n", (long)this );
	fflush(stdout);
  }


  QString text;
  text  = QString( "Version Numbers...\n");
  text += QString( QSAS_VERSION_ID);
  text += "\n Calc/Join ";
  text += QString(Qcalc_VERSION);
  QMessageBox::information( this, "QSAS information", text.toLatin1().data(), "OK" );

}



 void QcalcWindow::verboseToggle()
 {

 if ( QuSlotDebug() )
 {
   printf( "QcalcWindow::verboseToggle %ld\n", (long)this );
   fflush(stdout);
  }

  verbose = !verbose;
  toggleAction->setChecked(verbose);

}
